<template>
  <q-layout view="hHh lpR fFf" v-if="settings">

    <q-header elevated class="bg-primary text-white no-print">
      <q-toolbar>
          <q-avatar>
            <img src="~assets/bch.svg">
          </q-avatar>
          <span class="q-pl-sm">{{ settings.memo }} ({{ terminalId }})</span>
        <q-space />
        <q-btn dense flat round icon="menu" @click="toggleLeftDrawer" />
      </q-toolbar>
    </q-header>

    <q-drawer v-model="leftDrawerOpen" side="left" behavior="mobile" bordered>
      <q-list>
        <q-item-label header>Point-of-Sale</q-item-label>

        <!-- Checkout -->
        <q-item clickable to="checkout">
          <q-item-section avatar>
            <q-icon name="point_of_sale" />
          </q-item-section>

          <q-item-section>
            <q-item-label>Checkout</q-item-label>
          </q-item-section>
        </q-item>

        <!-- Settings -->
        <q-item clickable to="settings">
          <q-item-section avatar>
            <q-icon name="settings" />
          </q-item-section>

          <q-item-section>
            <q-item-label>Settings</q-item-label>
          </q-item-section>
        </q-item>

        <!-- Payment QR -->
        <q-item clickable to="payment-qr">
          <q-item-section avatar>
            <q-icon name="qr_code" />
          </q-item-section>

          <q-item-section>
            <q-item-label>QR Codes</q-item-label>
          </q-item-section>
        </q-item>

        <!-- Payment QR -->
        <q-item clickable to="extras">
          <q-item-section avatar>
            <q-icon name="add_location" />
          </q-item-section>

          <q-item-section>
            <q-item-label>Extras</q-item-label>
          </q-item-section>
        </q-item>

        <q-separator />

        <!-- Settings -->
        <q-item clickable type="a" href="https://scantopay.cash" target="_blank">
          <q-item-section avatar>
            <q-icon name="info" />
          </q-item-section>

          <q-item-section>
            <q-item-label>About</q-item-label>
          </q-item-section>
        </q-item>
      </q-list>
    </q-drawer>

    <q-page-container class="bg-white">
      <router-view v-slot="{ Component }">
        <transition appear enter-active-class="animated fadeIn slower">
          <Suspense @pending="showLoading" @resolve="hideLoading">
            <component :is="Component" />
          </Suspense>
        </transition>
      </router-view>
    </q-page-container>

  </q-layout>
</template>

<script setup lang="ts">
// Imports.
import { ref } from 'vue'
import { useRoute, useRouter } from 'vue-router'
import { useQuasar } from 'quasar'
import { useTerminalStore } from '../../stores/terminal-store'
import { storeToRefs } from 'pinia'
import { set } from 'idb-keyval'

// Framework constants.
const $q = useQuasar()
const $route = useRoute()
const $router = useRouter()
const terminalStore = useTerminalStore()

// Local constants.
const terminalId = $route.params.terminalId as string
const terminalPassword = $route.params.terminalPassword as string

// Reactive Variables.
const leftDrawerOpen = ref(false)
const { settings } = storeToRefs(terminalStore)

// Methods.
function toggleLeftDrawer () {
  leftDrawerOpen.value = !leftDrawerOpen.value
}

function showLoading (): void {
  $q.loading.show()
}

function hideLoading (): void {
  $q.loading.hide()
}

// Load the settings for this terminal from our backend.
await terminalStore.loadSettings(terminalId, terminalPassword)

// If an ID is not available (i.e. this Terminal has not been configured yet), then take user to setup page.
if (!terminalStore.settings) {
  // Navigate to the setup page and add the password as a query parameter.
  $router.push({
    path: `/setup/${terminalId}`,
    query: { pwd: terminalPassword }
  })
} else { // Set this terminal as the last used terminal.
  await set('lastUsedTerminalId', terminalId)
  await set('lastUsedTerminalPassword', terminalPassword)
}
</script>
